SystemOrganization addCategory: #'Parasol-Tests'!

WAFileLibrary subclass: #BPTestComponentFiles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Tests'!

!BPTestComponentFiles methodsFor: 'images' stamp: 'JohanBrichau 7/4/2014 13:32'!
testPng
	"Just a testfile"
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 80 0 0 0 50 8 6 0 0 0 203 45 92 252 0 0 0 38 73 68 65 84 104 129 237 193 49 1 0 0 0 194 160 245 79 109 7 111 160 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 224 49 62 178 0 1 194 74 156 166 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

WAComponent subclass: #BPTestComponent
	instanceVariableNames: 'inputFieldValue receivedFile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Tests'!

!BPTestComponent methodsFor: 'accessing' stamp: 'KrisGybels 4/11/2012 14:50'!
inputFieldValue

	^ inputFieldValue! !

!BPTestComponent methodsFor: 'accessing' stamp: 'KrisGybels 8/3/2012 12:34'!
receiveFile: file

	! !

!BPTestComponent methodsFor: 'accessing' stamp: 'KrisGybels 8/3/2012 13:02'!
receivedFile

	^ receivedFile! !

!BPTestComponent methodsFor: 'rendering' stamp: 'JohanBrichau 7/4/2014 13:15'!
renderContentOn: html

	html paragraph: 'Supercalifragilisticexpialidocious'.
	html form get; with: [
		html textInput id: 'inputField'; callback: [ :newValue | inputFieldValue := newValue ].
		html textInput name: 'secretField'; type: 'hidden'.
		html submitButton id: 'submitButton'.
	].
	html image id: 'image'; style: 'position:absolute;left:300px;top:400px'; url: (BPTestComponentFiles / #testPng).
	html div id: 'testDiv1'; with: [
		html paragraph id: 'testDiv1p'; class: 'c1'.
	].
	html div id: 'testDiv2'; with: [
		html paragraph id: 'testDiv2p1'; class: 'c2'.
		html paragraph id: 'testDiv2p2'; class: 'c1'.
		html paragraph id: 'testDiv2p3'; class: 'c1'.
	].
	html anchor id: 'anchor1'; with: 'A Link'.
	html anchor id: 'anchor2'; with: 'A Link'.
	html paragraph
		id: 'testParagraph';
		class: 'testclass';
		with: 'Bla bla'.
	html div
		class: 'testclass2';
		with: ''.
	html anchor
		class: 'testclass2';
		with: 'foobar'.
	html anchor
		url: 'http://en.wikipedia.org/wiki/Main_Page';
		target: '_blank';
		with: 'Wikipedia'.
	html form multipart; with: [
		html fileUpload callback: [ :value | receivedFile := value ].
		html submitButton id: 'sendFile'; with: 'Send File'
	].

! !

!BPPlatform class methodsFor: '*Parasol-Tests-development' stamp: 'KrisGybels 10/9/2015 12:41'!
generateJavaTestOn: stream

	stream
		nextPutAll: 'import org.junit.*;'; cr;
		nextPutAll: 'import static org.junit.Assert.*;'; cr;
		nextPutAll: 'import org.openqa.selenium.*;'; cr;
		cr;
		nextPutAll: 'public class Tests {'; cr;
		nextPutAll: '@Test'; cr;
		nextPutAll: 'public void testPlatform() {'; cr.

	self values do: [ :platform |
		stream 
			nextPutAll: 'assertSame("Test: family() of ';
			nextPutAll: platform name;
			nextPutAll: '", Platform.';
			nextPutAll: platform family name;
			nextPutAll: ', Platform.';
			nextPutAll: platform name;
			nextPutAll: '.family());';
			cr;
			nextPutAll: 'assertEquals("Test: toString() of ';
			nextPutAll: platform name;
			nextPutAll: '", "' , platform asString , '", Platform.';
			nextPutAll: platform name;
			nextPutAll: '.toString());';
			cr;
			nextPutAll: 'assertEquals("Test: getPartOfOsName() of ';
			nextPutAll: platform name;
			nextPutAll: '", new String[]{'.
		platform getPartOfOsName do: [ :part | stream nextPut: $"; nextPutAll: part; nextPut: $" ] separatedBy: [ stream nextPutAll: ', ' ].
		stream
			nextPutAll: '}, ';
			nextPutAll: 'Platform.';
			nextPutAll: platform name;
			nextPutAll: '.getPartOfOsName());';
			cr ].
	stream nextPutAll: '}}'; cr.
! !

TestCase subclass: #BPSmalltalkPlatformTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Tests'!

!BPSmalltalkPlatformTest methodsFor: 'tests' stamp: 'KrisGybels 10/9/2015 14:03'!
testJsonWebElement

	| json object |
	object := BPWebElement driver: nil elementID: 42.
	json := BPSmalltalkPlatform current jsonWrite: object.
	self assert: (json select: [:c | c ~=$ ]) = '{"ELEMENT":42}'.! !

!BPSmalltalkPlatformTest methodsFor: 'tests' stamp: 'KrisGybels 10/9/2015 14:03'!
testParseStatusFromJson

	| json status parsed |
	json := '{"sessionId":"1350900111656","status":0,"value":{"ELEMENT":"0"},"class":"org.openqa.selenium.remote.Response","hCode":1690596504}'.
	parsed := BPSmalltalkPlatform current jsonRead: json.
	status := parsed at: 'status'.
	self assert: 0 = status.! !

!BPSmalltalkPlatformTest methodsFor: 'tests' stamp: 'KrisGybels 10/9/2015 14:03'!
testParseWebElement

	| json parsed |
	json := '{"ELEMENT":"0"}'.
	parsed := BPSmalltalkPlatform current jsonRead: json.
	self assert: (parsed at: 'ELEMENT') = '0'! !

BPSeasideWebDriverTestCase subclass: #BPParasolSelfTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Tests'!

BPParasolSelfTestCase subclass: #BPMiscTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Tests'!

!BPMiscTestCase methodsFor: 'testing' stamp: 'KrisGybels 2/28/2017 14:51'!
testFileUpload

	| fileupload filesubmit file receivedFile |
	
	file := BPSmalltalkPlatform current fileWrite: 'Test.data' contents: 'Hello World!!'.

	[
		fileupload := driver findElementByXPath: ('//input[@type=''file'']').
		filesubmit := driver findElementByID: 'sendFile'.
		fileupload sendKeys: file.
		filesubmit click.
	
		receivedFile := self waitUntil: [ self componentUnderTest receivedFile ] is: [ :value | value notNil ]
			checkEvery: (Duration milliseconds: 100) timeoutAfter: (Duration seconds: 5) with: [ nil ].
		self assert: receivedFile notNil.
		self assert: (receivedFile contentsDecodedUsing: 'UTF-8') = 'Hello World!!'.
	] ensure: [  BPSmalltalkPlatform current fileDelete: file ].! !

!BPMiscTestCase methodsFor: 'testing' stamp: 'KrisGybels 10/9/2015 14:03'!
testPlatformIs

	self assert: ((BPPlatform valueOf: 'ANDROID') is: (BPPlatform valueOf: 'ANDROID')).
	self assert: ((BPPlatform valueOf: 'ANDROID') is: (BPPlatform valueOf: 'LINUX')).
	self assert: ((BPPlatform valueOf: 'ANDROID') is: (BPPlatform valueOf: 'UNIX')).
	self assert: ((BPPlatform valueOf: 'ANDROID') is: (BPPlatform valueOf: 'ANY')).
	self deny: ((BPPlatform valueOf: 'ANDROID') is: (BPPlatform valueOf: 'WINDOWS')).

	self assert: ((BPPlatform valueOf: 'WIN8_1') is: (BPPlatform valueOf: 'WINDOWS')).
	self deny: ((BPPlatform valueOf: 'WIN8_1') is: (BPPlatform valueOf: 'MAC')).
! !

!BPMiscTestCase methodsFor: 'testing' stamp: 'KrisGybels 10/9/2015 14:03'!
testPlatformJavaTestGeneration

	| stream |

	stream := WriteStream on: String new.
	BPPlatform generateJavaTestOn: stream.
	stream close.
	self assert: (stream contents findString: '@Test' startingAt: 1) > 0
		description: 'The generated Java test code should at least contain the @Test annotation'.
! !

!BPParasolSelfTestCase methodsFor: 'running' stamp: 'KrisGybels 12/23/2016 15:36'!
componentClass

	^ BPTestComponent ! !

!BPParasolSelfTestCase methodsFor: 'running' stamp: 'KrisGybels 1/25/2017 14:10'!
desiredDriverBrowserCapabilities

	^ BPDesiredCapabilities chrome! !

!BPParasolSelfTestCase methodsFor: 'private' stamp: 'KrisGybels 2/28/2017 14:39'!
waitUntil: valueBlock checkEvery: intervalDuration timeoutAfter: timeoutDuration

	^ self waitUntil: valueBlock value is: [ :value | value ] checkEvery: intervalDuration timeoutAfter: timeoutDuration with: [ :value | value ]! !

!BPParasolSelfTestCase methodsFor: 'private' stamp: 'KrisGybels 2/28/2017 14:39'!
waitUntil: valueBlock is: predicateBlock checkEvery: intervalDuration timeoutAfter: timeoutDuration with: alternativeValueBlock

	| stopDateTime value |
	
	stopDateTime := DateAndTime now + timeoutDuration.
	[
		value := valueBlock value.
		(predicateBlock value: value) ifTrue: [ ^ value ].
		(Delay forDuration: intervalDuration) wait.

		DateAndTime now < stopDateTime
	] whileTrue.
	^ alternativeValueBlock cull: value! !

BPParasolSelfTestCase subclass: #BPRemoteWebDriverTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Tests'!

!BPRemoteWebDriverTestCase class methodsFor: 'accessing' stamp: 'KrisGybels 5/22/2012 10:09'!
packageNamesUnderTest

	^ #('NextPlan-SeleniumTests-Common')! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'JohanBrichau 7/4/2014 13:20'!
configureTestApp: testApp

	testApp addLibrary: BPTestComponentFiles! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 1/25/2017 14:11'!
testClose

	self shouldnt: [ driver close ] raise: (BPNoSuchSessionException , BPUnknownServerException).
	self waitForDriverToFinishClosing.
	self should: [ driver close ] raise: (BPNoSuchSessionException , BPUnknownServerException).
! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 4/13/2012 09:48'!
testExecuteWith

	| inputField |
	self assert: (driver executeScript: '' with: #()) isNil.
	self assert: (driver executeScript: 'return 42' with: #()) = 42.
	self assert: (driver executeScript: 'return arguments[arguments[0]]' with: #(0)) = 0.
	self assert: (driver executeScript: 'return arguments[arguments[0]]' with: #(1 42)) = 42.
	
	inputField := driver findElementByID: 'inputField'.
	self assert: (driver executeScript: 'return arguments[0].getAttribute(''type'')' with: (Array with: inputField)) = 'text'.
! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 7/4/2012 10:00'!
testFindElementByCSSSelector

	| exceptionThrown |
	self assert: (driver findElementByCSSSelector: '#testDiv2 :nth-child(3)') = (driver findElementByID: 'testDiv2p3').
	exceptionThrown := false.
	"There seems to be an inconsistency between different versions of Selenium and/or different browsers, so two different exceptions might be thrown:"
	[[ driver findElementByCSSSelector: '#testDiv2 :nth-ch' ]
		on: BPInvalidSelectorException
		do: [ :ex | exceptionThrown := true. ]]
		on: BPUnknownServerException
		do: [ :ex | exceptionThrown := true. ].
	self assert: exceptionThrown.
! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 6/29/2012 15:20'!
testFindElementByClassName

	self assert: (driver findElementByClassName: 'testclass') = (driver findElementByID: 'testParagraph').
	self should: [ driver findElementByClassName: 'inexistantclass' ] raise: BPNoSuchElementException.
	
! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 6/29/2012 15:20'!
testFindElementByID

	self shouldnt: [ driver findElementByID: 'inputField' ] raise: BPNoSuchElementException.
	self should: [ driver findElementByID: 'elementThatDoesNotExist' ] raise: BPNoSuchElementException.
! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 6/29/2012 15:19'!
testFindElementByLinkText

	self assert: (driver findElementByLinkText: 'A Link') = (driver findElementByID: 'anchor1').
	self deny: (driver findElementByLinkText: 'A Link') = (driver findElementByID: 'anchor2').
	
	self should: [ driver findElementByLinkText: 'Link' ] raise: BPNoSuchElementException.
! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 6/29/2012 15:19'!
testFindElementByName

	self shouldnt: [ driver findElementByName: 'secretField' ] raise: BPNoSuchElementException.
	self should: [ driver findElementByName: 'elementThatDoesNotExist' ] raise: BPNoSuchElementException.
	self flag: 'Expand this test to check what happens when there are multiple elements with the same name.'.
! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 6/29/2012 15:20'!
testFindElementByPartialLinkText

	self assert: (driver findElementByPartialLinkText: 'Link') = (driver findElementByID: 'anchor1').
	self deny: (driver findElementByPartialLinkText: 'Link') = (driver findElementByID: 'anchor2').
	
	self should: [ driver findElementByPartialLinkText: 'Lxnk' ] raise: BPNoSuchElementException.
! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 6/29/2012 15:19'!
testFindElementByTagName

	self assert: (driver findElementByTagName: 'input') = (driver findElementByID: 'inputField').
	self should: [ driver findElementByTagName: 'tagThatIsNeverUsed' ] raise: BPNoSuchElementException.
! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 6/29/2012 15:18'!
testFindElementByXPath

	self assert: (driver findElementByXPath: '//div[@id=''testDiv1'']') = (driver findElementByID: 'testDiv1').
	self assert: (driver findElementByXPath: '//div[@id=''testDiv2'']') = (driver findElementByID: 'testDiv2').
	self should: [ driver findElementByXPath: '//div[@id=' ] raise: BPInvalidSelectorException.! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'JohanBrichau 5/18/2012 17:11'!
testFindElementsByClassName

	self assert: (driver findElementsByClassName: 'testclass2') size = 2.
	
! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'AndyKellens 2/13/2013 16:49'!
testFindElementsByPartialLinkTest

	self flag: 'Write this test'.! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 10/2/2012 11:48'!
testFindElementsByXPath

	self flag: 'Write this test.'.! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 1/25/2017 14:11'!
testGetCapabilities

	| capabilities platform |
	
	capabilities := driver getCapabilities.

	self assert: capabilities getBrowserName = 'chrome'.
	
	platform := capabilities getPlatform.
	self assert: (#('ANY' 'MAC' 'WINDOWS' 'UNIX' 'LINUX') includes: platform family name).
	self assert: (platform is: (BPPlatform valueOf: 'ANY')).
	self assert:
		(((platform is: (BPPlatform valueOf: 'MAC'))
			xor: (platform is: (BPPlatform valueOf: 'UNIX')))
			xor: (platform is: (BPPlatform valueOf: 'WINDOWS'))).
! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 2/27/2017 16:53'!
testGetCurrentURL

	self assert: driver getCurrentURL = self baseURL.

	driver get: 'https://en.wikipedia.org/wiki/Smalltalk-80'.
	self assert: driver getCurrentURL = 'https://en.wikipedia.org/wiki/Smalltalk'. "There is a redirect from Smalltalk-80 to Smalltalk."

	(driver findElementByPartialLinkText: 'External links') click.
	self assert: driver getCurrentURL = 'https://en.wikipedia.org/wiki/Smalltalk#External_links'.
! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 1/25/2017 14:12'!
testGetPageSource

	self assert: (driver getPageSource findString: 'Supercalifragilisticexpialidocious') > 0.
	driver close.
	self waitForDriverToFinishClosing.
	self should: [ driver getPageSource ] raise: BPNoSuchSessionException.
! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 10/9/2015 14:03'!
testGetScreenshotAsByteArray

	|  form screenshotByteArray |

	screenshotByteArray := driver getScreenshotAsByteArray.
	form := BPSmalltalkPlatform current pngImageFromByteArray: screenshotByteArray.
	self assert: form width > 0.
	self assert: form height > 0.! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 5/23/2012 19:03'!
testGetWindowHandle

	self assert: (driver getWindowHandle) isEmpty not.	! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 5/23/2012 19:04'!
testGetWindowHandles

	self assert: (driver getWindowHandles) = (Array with: driver getWindowHandle).! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 9/8/2013 20:17'!
testImplicitWait

	self flag: 'Write this test'.! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 5/23/2012 19:53'!
testSwitchTo

	| windowHandle1 windowHandle2 |

	windowHandle1 := driver getWindowHandle.
	self assert: driver getTitle = 'Seaside'.
	self assert: driver getWindowHandles = (Array with: windowHandle1).

	(driver findElementByPartialLinkText: 'Wikipedia') click.
	self assert: driver getWindowHandle = windowHandle1.
	self assert: driver getTitle = 'Seaside'.
	self assert: driver getWindowHandles size = 2.

	windowHandle2 := (driver getWindowHandles copyWithout: windowHandle1) first.
	driver switchTo window: windowHandle2.
	self assert: driver getWindowHandle = windowHandle2.
	self assert: (driver getTitle beginsWith: 'Wikipedia').
! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 1/25/2017 12:36'!
testSwitchToActiveElement

	| inputFieldElement |
	
	self assert: (driver switchTo activeElement) = (driver findElementByTagName: 'body').

	inputFieldElement := driver findElementByID: 'inputField'.
	inputFieldElement click.
	self assert: (driver switchTo activeElement) = inputFieldElement.
! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testTakeScreenshot

	| filename |
	filename := self takeScreenshot.! !

!BPRemoteWebDriverTestCase methodsFor: 'misc' stamp: 'KrisGybels 4/10/2012 16:03'!
waitForDriverToFinishClosing

	self flag: 'Check whether there is a better way to do this rather than just waiting for a set amount of time'.
	(Delay forSeconds: 1) wait.! !

BPParasolSelfTestCase subclass: #BPWebElementTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Tests'!

!BPWebElementTestCase class methodsFor: 'instance creation' stamp: 'haerle 8/19/2014 14:55'!
new
	"Answer a newly created and initialized instance."

	^super new initialize! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'KrisGybels 2/28/2017 15:00'!
testClear

	| inputField submitButton secretField submittedValue |
	
	inputField := driver findElementByID: 'inputField'.
	submitButton := driver findElementByID: 'submitButton'.

	inputField sendKeys: 'XYZ'.
	inputField clear.
	inputField sendKeys: 'ABC'.
	inputField sendKeys: 'DEF'.
	submitButton click.
	submittedValue := self waitUntil: [ self componentUnderTest inputFieldValue ] is: [ :value | value notNil ]
		checkEvery: (Duration milliseconds: 100) timeoutAfter: (Duration seconds: 5) with: [ nil ].
	self assert: submittedValue equals: 'ABCDEF'.

	self should: [ inputField clear ] raise: BPStaleElementReferenceException.

	driver get: self baseURL asString.
	secretField := driver findElementByName: 'secretField'.
	self should: [ secretField clear ] raise: (BPElementNotVisibleException , BPInvalidElementStateException).
! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'haerle 8/19/2014 14:55'!
testClearShouldClearFieldThatWasJustFilled

	| inputField |
	inputField := driver findElementByID: 'inputField'.
	inputField sendKeys: 'XYZ'.
	inputField clear.
	
	self assert: inputField getText = ''! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'CarstenHaerle 9/11/2014 16:29'!
testCssClassNames

	| testElement |
	testElement := driver findElementByID: 'testDiv2p1'.
	self assert: (testElement cssClassNames) asArray = #('c2')! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'KrisGybels 4/12/2012 11:06'!
testEquals

	| testDiv1 testDiv1p testDiv1pByID testDiv1pByClassName testDiv2 |
	
	testDiv1 := driver findElementByID: 'testDiv1'.
	testDiv2 := driver findElementByID: 'testDiv2'.
	testDiv1pByID := driver findElementByID: 'testDiv1p'.
	testDiv1pByClassName := testDiv1 findElementByClassName: 'c1'.

	self flag: 'testDiv1pByID and testDiv1pByClassName do seem to have the same elementID; would be nice to expand this test with a case where the two elementIDs are not the same while still referring to the same element.'.
	self assert: testDiv1pByID = testDiv1pByClassName.
	self deny: testDiv1 = testDiv2.
	
	driver get: self baseURL asString.
	self flag: 'Should this not throw a stale element reference exception??'.
	self assert: testDiv1pByID = testDiv1pByClassName.! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'KrisGybels 6/29/2012 15:20'!
testFindElementByClassName

	| testDiv1 testDiv2 testDiv1p testDiv2p1 testDiv2p2 testDiv2p3 |
	testDiv1 := driver findElementByID: 'testDiv1'.
	testDiv2 := driver findElementByID: 'testDiv2'.

	testDiv1p := driver findElementByID: 'testDiv1p'.
	testDiv2p1 := driver findElementByID: 'testDiv2p1'.
	testDiv2p2 := driver findElementByID: 'testDiv2p2'.
	testDiv2p3 := driver findElementByID: 'testDiv2p3'.
	
	self assert: (testDiv1p getAttribute: 'class') = 'c1'.
	self assert: (testDiv2p1 getAttribute: 'class') = 'c2'.
	self assert: (testDiv2p2 getAttribute: 'class') = 'c1'.
	self assert: (testDiv2p3 getAttribute: 'class') = 'c1'.
	
	self assert: ((testDiv1 findElementByClassName: 'c1') getAttribute: 'id') = 'testDiv1p'.
	self assert: ((testDiv2 findElementByClassName: 'c1') getAttribute: 'id') = 'testDiv2p2'.
	self assert: ((testDiv2 findElementByClassName: 'c2') getAttribute: 'id') = 'testDiv2p1'.
	
	self should: [ testDiv1 findElementByClassName: 'unusedClassName' ] raise: BPNoSuchElementException.
! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'KrisGybels 2/28/2017 13:55'!
testFindElementByLinkText

	| testElement |
	
	testElement := driver findElementByLinkText: 'Wikipedia'.
	self assert: (testElement getAttribute: 'href') = 'http://en.wikipedia.org/wiki/Main_Page'.

	self should: [ driver findElementByLinkText: 'wikipedia' ] raise: BPNoSuchElementException.
	self should: [ driver findElementByLinkText: 'ikipedia' ] raise: BPNoSuchElementException.
	self should: [ driver findElementByLinkText: 'Wikipedi' ] raise: BPNoSuchElementException.
	self should: [ driver findElementByLinkText: 'ikipedi' ] raise: BPNoSuchElementException.
! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'CarstenHaerle 9/11/2014 16:30'!
testFindElementByTagName

	| testElement |
	testElement := driver findElementByTagName: 'input'.
	self assert: (testElement getAttribute: 'id') = 'inputField'.! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'TravisCI 4/24/2016 15:33'!
testFindElementsByClassName

	| testElement |
	testElement := driver findElementByClassName: 'testclass'.
	self assert: (testElement getAttribute: 'id') = 'testParagraph'.! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'CarstenHaerle 9/11/2014 16:30'!
testFindElementsByPartialLinkText

	| testElement |
	testElement := driver findElementByPartialLinkText: 'Wiki'.
	self assert: (testElement getAttribute: 'href') = 'http://en.wikipedia.org/wiki/Main_Page'.! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'CarstenHaerle 9/11/2014 16:30'!
testFindElementsByTagName

	| testElements |
	testElements := driver findElementsByTagName: 'form'.
	self assert: (testElements collect: [:each | each getAttribute: 'method']) = #('get' 'post')! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'KrisGybels 4/11/2012 14:46'!
testGetAttribute

	| inputField |
	inputField := driver findElementByID: 'inputField'.
	self assert: (inputField getAttribute: 'type') = 'text'.
	self assert: (inputField getAttribute: 'id') = 'inputField'.
	self assert: (inputField getAttribute: 'attributeThatIsNotSpecified') isNil.
! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'KrisGybels 4/11/2012 14:04'!
testGetLocation

	| imageElement |
	imageElement := driver findElementByID: 'image'.
	self assert: (imageElement getLocation) =  (300@400).
! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'KrisGybels 4/11/2012 14:04'!
testGetSize

	| imageElement |
	imageElement := driver findElementByID: 'image'.
	self assert: (imageElement getSize) = (80@50).
! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'KrisGybels 4/15/2012 16:05'!
testGetText

	| paragraphElement |
	paragraphElement := driver findElementByTagName: 'p'.
	self assert: paragraphElement getText = 'Supercalifragilisticexpialidocious'.
! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'KrisGybels 4/11/2012 14:45'!
testIsDisplayed

	| inputField secretField |
	inputField := driver findElementByID: 'inputField'.
	secretField := driver findElementByName: 'secretField'.
	self assert: inputField isDisplayed.
	self deny: secretField isDisplayed.
! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'KrisGybels 2/28/2017 14:29'!
testSendKeys

	| inputElement submitButton submittedValue |
	self assert: self componentUnderTest inputFieldValue isNil.
	inputElement := driver findElementByID: 'inputField'.
	inputElement sendKeys: 'XYZ'.
	submitButton := driver findElementByID: 'submitButton'.
	submitButton click.
	submittedValue := self waitUntil: [ self componentUnderTest inputFieldValue ] is: [ :value | value notNil ]
		checkEvery: (Duration milliseconds: 100) timeoutAfter: (Duration seconds: 5) with: [ nil ].
	self assert: submittedValue equals: 'XYZ'.

	driver get: self baseURL asString.
	self assert: self componentUnderTest inputFieldValue isNil.
	self should: [ inputElement sendKeys: 'XYZ' ] raise: BPStaleElementReferenceException.
! !

BPParasolSelfTestCase subclass: #BPWindowTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Tests'!

!BPWindowTestCase methodsFor: 'running' stamp: 'JohanBrichau 5/6/2016 08:22'!
configureTestApp: testApp

	testApp configuration 
		takeValue: #()
		forAttribute: (testApp configuration attributeAt: #rootDecorationClasses).! !

!BPWindowTestCase methodsFor: 'running' stamp: 'KrisGybels 11/6/2012 12:06'!
testPosition

	| window1 windowHandle1 windowHandle2 window2 |
	
	window1 := driver manage window.
	window1 setPosition: 25@30.
	self assert: window1 getPosition = (25@30).
	
	windowHandle1 := driver getWindowHandle.
	(driver findElementByPartialLinkText: 'Wikipedia') click.
	windowHandle2 := (driver getWindowHandles copyWithout: windowHandle1) first.
	driver switchTo window: windowHandle2.

	self flag: 'The following does not work, need to figure out why not'.
"	window2 := driver manage window.
	
	window1 setPosition: 52@66.
	window2 setPosition: 63@74.
	self assert: window1 getPosition = (52@66).
	self assert: window2 getPosition = (63@74)."
! !

!BPWindowTestCase methodsFor: 'running' stamp: 'KrisGybels 2/28/2017 14:38'!
testSize

	| window1 windowHandle1 windowHandle2 |
	
	window1 := driver manage window.
	window1 setSize: 500@600.
	self assert: window1 getSize = (500@600).
	
	windowHandle1 := driver getWindowHandle.
	(driver findElementByPartialLinkText: 'Wikipedia') click.
	self assert: (self waitUntil: [ driver getWindowHandles size > 1 ] checkEvery: (Duration milliseconds: 100) timeoutAfter: (Duration seconds: 5)).
	windowHandle2 := (driver getWindowHandles copyWithout: windowHandle1) first.
	driver switchTo window: windowHandle2.

	self flag: 'The following does not work, need to figure out why not'.
"	window2 := driver manage window.
	
	window1 setSize: 210@300.
	window2 setSize: 255@290.
	self assert: window1 getSize = (210@300).
	self assert: window2 getSize = (255@290)."
! !
